Question

App starting with heroku-18 stack

Hi there, today I rebooted my DigitalOcean app and kept encountering build errors.

 -15 19:40:58] │ -----> Using Python version specified in runtime.txt
[2023-08-15 19:40:59] │  !     Requested runtime 'python-3.10.4' is not available for this stack (heroku-18).
[2023-08-15 19:40:59] │  !     For supported versions, see: https://devcenter.heroku.com/articles/python-support
[2023-08-15 19:40:59] │ ERROR: failed to build: exit status 1
[2023-08-15 19:40:59] │ 
[2023-08-15 19:40:59] │ 
[2023-08-15 19:40:59] │ For documentation on the buildpacks used to build your app, please see:
[2023-08-15 19:40:59] │ 
[2023-08-15 19:40:59] │    Python  v2.231.4  https://do.co/apps-buildpack-python
[2023-08-15 19:40:59] │ 
[2023-08-15 19:40:59] │  ✘ build failed

It is surprising to me that DigitalOcean apps utilize heroku-18 since that has been officially declared as end-of-life since april 30th. Is there anyway that I can upgrade this heroku version so it can support my current Python version?

As addition, running the app with the supposed supported runtimes (https://devcenter.heroku.com/articles/python-support#supported-runtimes) also threw a build error.


Submit an answer


This textbox defaults to using Markdown to format your answer.

You can type !ref in this text area to quickly search our full set of tutorials, documentation & marketplace offerings and insert the link!

Sign In or Sign Up to Answer

These answers are provided by our Community. If you find them useful, show some love by clicking the heart. If you run into issues leave a comment, or add your own answer to help others.

Jon Friesen
DigitalOcean Employee
DigitalOcean Employee badge
August 16, 2023

👋 hello,

Thanks for reaching out. For better support for newer Python runtimes, consider upgrading your app to our ubuntu-22 stack.

You can do this by adding a flag to your app spec (in app settings):

features:
    - buildpack-stack=ubuntu-22

A full example spec could be:

name: sample-python
features:
  - buildpack-stack=ubuntu-22
services:
- github:
    branch: main
    repo: digitalocean/sample-python
  http_port: 8080
  instance_count: 1
  instance_size_slug: basic-xxs
  name: web
  routes:
  - path: /
Bobby Iliev
Site Moderator
Site Moderator badge
August 16, 2023

Hi there,

I could suggest checking if there are any buildpacks upgrades available for your app.

To upgrade all of the app’s and its components’ buildpacks simultaneously, go to the control panel and click on the app with buildpacks you want to upgrade. Then, click on the app’s Overview tab. If any buildpacks have available upgrades, this page has a card titled Buildpack Upgrades Available. To upgrade, click the Deploy Upgrades button in this card. Note that this process redeploys your app.

If there are no buildpack upgrades available, is your repository open-source by any chance? If so, can you share a link here so I could take a look and see if there are any configuration settings that might be causing the problem?

Best,

Bobby

Try DigitalOcean for free

Click below to sign up and get $200 of credit to try our products over 60 days!

Sign up

Get our biweekly newsletter

Sign up for Infrastructure as a Newsletter.

Hollie's Hub for Good

Working on improving health and education, reducing inequality, and spurring economic growth? We'd like to help.

Become a contributor

Get paid to write technical tutorials and select a tech-focused charity to receive a matching donation.

Welcome to the developer cloud

DigitalOcean makes it simple to launch in the cloud and scale up as you grow — whether you're running one virtual machine or ten thousand.

Learn more
DigitalOcean Cloud Control Panel